require "todoplicator/adapter_registry"
require "todoplicator/find_adapter"
require "todoplicator/git_hub_adapter"
require "todoplicator/git_lab_adapter"

class Todoplicator
  class UnknownAdapter < StandardError; end

  def initialize(source, destination)
    @source = FindAdapter.call(source)
    @destination = FindAdapter.call(destination)
  end

  def copy
    issues_to_copy.map { |i| create_issue(i) }
  end

private

  def issues_to_copy
    @source.find_issues
  end

  def create_issue(issue)
    @destination.create_issue(issue)
  end
end
