class Todoplicator
  class AdapterRegistry
    def self.instance
      @@instance ||= new
    end

    def initialize
      reset!
    end

    def add(key, klass)
      @adapters[key.to_sym] = klass
    end

    def for(key)
      @adapters.fetch(key.to_sym) { raise UnknownAdapter, "#{key} not found" }
    end

    def all
      @adapters
    end

    def reset!
      @adapters = {}
    end
  end
end
